POJ 1552 BUY LOW, BUY LOWER(最长单调递减子序列求方案数)

BUY LOW, BUY LOWER

Time Limit: 1000MS   Memory Limit: 30000K
     

Description

The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also follow this problems‘ advice:

                    "Buy low; buy lower"

Each time you buy a stock, you must purchase it at a lower price than the previous time you bought it. The more times you buy at a lower price than before, the better! Your goal is to see how many times you can continue purchasing at ever lower prices.

You will be given the daily selling prices of a stock (positive 16-bit integers) over a period of time. You can choose to buy stock on any of the days. Each time you choose to buy, the price must be strictly lower than the previous time you bought stock. Write
a program which identifies which days you should buy stock in order to maximize the number of times you buy.

Here is a list of stock prices:

 Day   1  2  3  4  5  6  7  8  9 10 11 12

Price 68 69 54 64 68 64 70 67 78 62 98 87

The best investor (by this problem, anyway) can buy at most four times if each purchase is lower then the previous purchase. One four day sequence (there might be others) of acceptable buys is:

Day    2  5  6 10

Price 69 68 64 62

Input

* Line 1: N (1 <= N <= 5000), the number of days for which stock prices are given

* Lines 2..etc: A series of N space-separated integers, ten per line except the final line which might have fewer integers.

Output

Two integers on a single line:

* The length of the longest sequence of decreasing prices

* The number of sequences that have this length (guaranteed to fit in 31 bits)

In counting the number of solutions, two potential solutions are considered the same (and would only count as one solution) if they repeat the same string of decreasing prices, that is, if they "look the same" when the successive prices are compared. Thus,
two different sequence of "buy" days could produce the same string of decreasing prices and be counted as only a single solution.

Sample Input

12
68 69 54 64 68 64 70 67 78 62
98 87

Sample Output

4 2

题意:给出n个数,求最长单调递减子序列的长度L,并求出有多少个序列的长度为L。

注意:5 3 1, 5 3 1算一种方案。

分析:因为n不超过5000,所以O(n^2)复杂度可以接受。那么我们就可以按照平时求最长单调递减子序列的方法,在求的时候加上一个辅助数组cnt[i]记录从开始到第i个位置,单调递减子序列为dp[i]时的方案数。

#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
const int N = 1e4 + 10;
int a[N], dp[N], cnt[N];
int main() {
    int n;
    while(~scanf("%d", &n)) {
        for(int i = 0; i < n; i++) {
            scanf("%d", &a[i]);
            dp[i] = 1;
            cnt[i] = 1;
        }
        for(int i = 1; i < n; i++) {
            for(int j = i - 1; j >= 0; j--) {
                if(a[i] < a[j]) {
                    if(dp[i] < dp[j] + 1) { // 第一次找到能使长度变长的元素
                        dp[i] = dp[j] + 1;
                        cnt[i] = cnt[j];
                    }
                    else if(dp[i] == dp[j] + 1) // 之前已经找到了一个使得dp[i] = dp[j] +1的元素,现在又找到一个
                        cnt[i] += cnt[j];
                }
                else {
                    if(a[i] == a[j]) {
                        if(dp[i] == 1) //用第i个位置上的数字替换第j个位置上的数字,形成的序列完全相同
                            cnt[i] = 0;
                        break;
                    }
                }
            }
        }
        int max_len = 0, ans_cnt = 0;
        for(int i = 0; i < n; i++)
            max_len = max(max_len, dp[i]);
        for(int i = 0; i < n; i++)
            if(dp[i] == max_len)
                ans_cnt += cnt[i];
        printf("%d %d\n", max_len, ans_cnt);
    }
    return 0;
}
时间: 2024-12-20 19:17:22

POJ 1552 BUY LOW, BUY LOWER(最长单调递减子序列求方案数)的相关文章

poj 1952 BUY LOW, BUY LOWER 最长下降子序列+统计不重复方案数

dp[i]=max(dp[i],dp[j]+1) j<i且a[j]>a[i] dp[i]表示长度为i的最长下降子序列的长度. r[i]表示长度为i的最长下降子序列的方案数. 考虑这样一个问题,比如6 3 9 3,对于两个3,他们数字一样并且dp值也一样,那么r[2]的方案数是没有意义的 因为能通过第一个3扩展的也能通过第二个3扩展,所以直接把r[2]=0. 对于一次扩展若dp[j]+1==dp[i],则说明j的路线和i的路线都可以用则r[i]+=r[j] 若dp[j]+1>dp[i],则

usaco 4.3 Buy Low, Buy Lower

http://train.usaco.org/usacoprob2?a=7BaJNgFLmpD&S=buylow 求最长递减子序列以及方案数,注意重复不算,比如 3 2 3 2 1 ,这里取到最长递减子序列算一种(3 2 1). 思路: 最长递减子序列的长度可以直接dp: dp[i]=max(dp[j]+1) (j<i&&a[j]<a[i]). 而方案数,如果不重复的话,在dp的过程中记录下就可以求了,设cnt[i]为以a[i]为结尾的方案数,那么推完dp的值之后再推一

poj 1952 BUY LOW, BUY LOWER (最长递减子序列+不同子序列计数)

BUY LOW, BUY LOWER Time Limit: 1000MS   Memory Limit: 30000K Total Submissions: 8327   Accepted: 2888 Description The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also f

poj 1952 BUY LOW, BUY LOWER[最长单调子序列变形]

题目:poj 1952 BUY LOW, BUY LOWER 题意:给出一个序列,先求最长单调递减子序列,然后求在子序列最长的情况下,不同的长度都为最长的的子序列的个数.(比如3,2,1和3,2,1属于相同,只能算一个) 分析:首先用一个dp[i]表示到当前i点的最长子序列的长度 用dp2[i]表示最长为dp[i]的子序列的个数 然后dp[i] = max(dp[j])+1 (1<=j /************************************ Problem: 1952 Use

POJ 1952 BUY LOW, BUY LOWER

BUY LOW, BUY LOWER Time Limit: 1000MS   Memory Limit: 30000K Total Submissions: 8311   Accepted: 2883 Description The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also f

POJ 1952 BUY LOW, BUY LOWER 动态规划题解

Description The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also follow this problems' advice: "Buy low; buy lower" Each time you buy a stock, you must purcha

【dp】PKU 1952 buy low,buy lower

题目链接: http://poj.org/problem?id=1952 Usaco 4.3.1 Buy Low, Buy Lower By 小兔齐齐 描述 “逢低吸纳”是炒股的一条成功秘诀.如果你想成为一个成功的投资者,就要遵守这条秘诀: "逢低吸纳,越低越买" 这句话的意思是:每次你购买股票时的股价一定要比你上次购买时的股价低.按照这个规则购买股票的次数越多越好,看看你最多能按这个规则买几次. 给定连续的N天中每天的股价.你可以在任何一天购买一次股票,但是购买时的股价一定要比你上次

BUY LOW, BUY LOWER_最长下降子序列

Description The advice to "buy low" is half the formula to success in the bovine stock market.To be considered a great investor you must also follow this problems' advice: "Buy low; buy lower" Each time you buy a stock, you must purcha

USACO Section 4.3 Buy low,Buy lower

第一眼看到题目,感觉水水的,不就是最长下降子序列嘛!然后写……就呵呵了..要判重,还要高精度……判重我是在计算中加入各种判断.这道题比看上去麻烦一点,但其实还好吧.. #include<cstdio> #include<cstring> #include<iostream> #include<algorithm> #define rep(i,l,r) for(int i=l;i<r;i++) #define clr(x,c) memset(x,c,si